#include "StdAfx.h"
#include "FTStateRecv.h"
#include "UIChatFileElement.h"
#include "FTSLayoutOffset.h"
#include "Resource.h"

using namespace ftsLayOutOffset;

namespace FileTransferState
{
	CFTStateRecvBase::CFTStateRecvBase(UIChatFileElement * pUIElem)
		:CFTState(pUIElem)
	{
		int nDisplayType = m_pUIChatFileElement->GetElementResource()->GetChatDisplayType();
		//most recv status define, except for (Bubble->Progress)
		m_alignmentFileName = StringAlignmentNear;
		m_alignmentButton[Button_General] = StringAlignmentNear;
		m_alignmentProgress = StringAlignmentNear;

		m_bButtonIsLink[Button_General] = TRUE;
		m_clrButtonText[Button_General] = GetCurrentLayout(nDisplayType).common().clr_text_link;

		m_fontStyleButtonText[Button_General] = FontStyleUnderline;
		m_bShowDivider = TRUE;
		m_bWillDisplayFileSize = TRUE;
		
		
	}

	void CFTStateRecvBase::_SetControlPos(const CPoint& ptPos, CSize& sz, DWORD dwFlags)
	{
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		PointF ptOffset((REAL)ptPos.x, (REAL)ptPos.y);

		CRect rc_view = pResource->GetViewRect();
		int nDisplayType = pResource->GetChatDisplayType();
		
		if (CHAT_BUBBLE == nDisplayType)
		{
			m_rcFileIcon.X = ptOffset.X;
			m_rcFileIcon.Y = ptOffset.Y;

			//m_rcFileName.X = m_rcFileIcon.GetRight() + GetCurrentLayout(nDisplayType).recv().filename_to_icon_left;
			//m_rcFileName.Y = m_rcFileIcon.Y + GetCurrentLayout(nDisplayType).recv().filename_to_icon_top;

			//m_rcFileName.Width = rc_view.Width() - DEF_ITEM_POS_RIGHT_REL_X - GetCurrentLayout().recv().filename_to_item_right - m_rcFileName.X;

			/*m_rcProgress.X = m_rcFileName.X;
			m_rcProgress.Y = m_rcFileName.Y + m_rcFileName.Height + GetCurrentLayout(nDisplayType).recv().progress_to_filename_top;

			m_rcProgressExtraStatus.X = m_rcProgress.GetRight();
			m_rcProgressExtraStatus.Y = m_rcProgress.GetTop();

			//if (!m_strProgressExtraStatus.IsEmpty())
			//{
			//	//just plain translating
			//	m_rcProgressExtraStatus.X += 4;
			//}

			if (m_bShowDivider)
			{
				m_rcDivider.X = m_rcProgressExtraStatus.GetRight() + GetCurrentLayout(nDisplayType).common().divider_to_progressOrStatus_left;
				m_rcDivider.Y = m_rcProgressExtraStatus.Y + GetCurrentLayout(nDisplayType).common().divider_height_offset;
				m_rcButton[Button_General].X = m_rcDivider.GetRight() + GetCurrentLayout(nDisplayType).common().button_to_divider_left;
			}
			else
			{
				m_rcButton[Button_General].X = m_rcProgress.GetRight();
				if (m_rcProgress.Width > 0)
				{
					m_rcButton[Button_General].X += GetCurrentLayout(nDisplayType).send().cancel_to_progress_right;
				}
			}
			//m_rcButton[Button_General].X = m_rcProgress.GetRight() + GetCurrentLayout().recv().button_to_progress_right;
			m_rcButton[Button_General].Y = m_rcProgress.Y;

			sz.cy += m_rcFileIcon.Height;*/
		}
		else if(CHAT_PLAIN == nDisplayType)
		{
			m_rcFileIcon.X = ptOffset.X;
			m_rcFileIcon.Y = ptOffset.Y;

			m_rcFileName.X = m_rcFileIcon.GetRight() + GetCurrentLayout(nDisplayType).recv().filename_to_icon_left;
			m_rcFileName.Y = m_rcFileIcon.Y + GetCurrentLayout(nDisplayType).recv().filename_to_icon_top;

			//m_rcFileName.Width = rc_view.Width() - DEF_ITEM_POS_RIGHT_REL_X - GetCurrentLayout().recv().filename_to_item_right - m_rcFileName.X;

			m_rcProgress.X = m_rcFileName.X;
			m_rcProgress.Y = m_rcFileName.Y + m_rcFileName.Height + GetCurrentLayout(nDisplayType).recv().progress_to_filename_top;


			m_rcProgressExtraStatus.X = m_rcProgress.GetRight();
			m_rcProgressExtraStatus.Y = m_rcProgress.GetTop();

			//if (!m_strProgressExtraStatus.IsEmpty())
			//{
			//	//just plain translating
			//	m_rcProgressExtraStatus.X += 4;
			//}

			if (m_bShowDivider)
			{
				m_rcDivider.X = m_rcProgressExtraStatus.GetRight() + GetCurrentLayout(nDisplayType).common().divider_to_progressOrStatus_left;
				m_rcDivider.Y = m_rcProgressExtraStatus.Y + GetCurrentLayout(nDisplayType).common().divider_height_offset;
				m_rcButton[Button_General].X = m_rcDivider.GetRight() + GetCurrentLayout(nDisplayType).common().button_to_divider_left;
			}
			else
			{
				m_rcButton[Button_General].X = m_rcProgress.GetRight();
				if (m_rcProgress.Width > 0)
				{
					m_rcButton[Button_General].X += GetCurrentLayout(nDisplayType).send().cancel_to_progress_right;
				}
			}
			m_rcButton[Button_General].Y = m_rcProgress.Y;
	
			sz.cy = GetCurrentLayout(nDisplayType).recv().icon_to_item_top + m_rcFileIcon.Height + GetCurrentLayout(nDisplayType).recv().icon_to_item_bottom;
		}
	}

	void CFTStateRecvBase::_CalcFileNameSize(const CPoint& ptOffset)
	{
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();
		int nChatType = pResource->GetChatDisplayType();
		const commonInfo& cmmInfo = GetCurrentLayout(nChatType).common();
		const recvInfo&  recv = GetCurrentLayout(nChatType).recv();
		m_clrFileName = recv.filename_color;
		CRect rcRect = pResource->GetViewRect();
		if(CHAT_BUBBLE == nChatType)
		{
			int nWidth = rcRect.Width() - ptOffset.x - _GetBubbleImage(FALSE, 0)->GetWidth() - _GetBubbleImage(FALSE, 2)->GetWidth()
				- DEF_CHAT_MSG_BUBBLE_ARROR_RIGHT_X;

			if(nWidth < m_nBubble_Inner_width_min)
			{
				nWidth = m_nBubble_Inner_width_min;
			}
			RectF rcFDraw(0.0, 0.0, nWidth, 1000.0);
			CRect rcDraw(0, 0, nWidth, 1000);
			CString strDisplayFileName = _CalcDisplayFileNameString(rcFDraw);

			CSize szBound( 0, 0);
			REAL fontHeight = 8;
			RecalcTextRectVert(pResource->GetCurrentWnd(), strDisplayFileName, g_defaultFontFaceName, fontHeight, 
				FontStyleRegular, rcDraw, szBound);

			m_rcFileName.X = m_rcFileIcon.X + _GetBubbleImage(FALSE, 0)->GetWidth();
			m_rcFileName.Y = m_rcFileIcon.Y + cmmInfo.icon_file_type_height + cmmInfo.GetFileIconEdgeY() +
				recv.filename_to_icon_top;

			m_rcFileName.Width = (REAL)szBound.cx;
			m_rcFileName.Height = (REAL)szBound.cy;
		}
		else
		{
			
			int nWidth = rcRect.Width() - cmmInfo.GetFileIconWidth() - ptOffset.x - recv.filename_to_icon_left - recv.filename_to_item_right;
			RectF rcDraw(0.0, 0.0, nWidth, cmmInfo.font_height);
			CString strDisplayFileName = _CalcDisplayFileNameString(rcDraw);
			CSize szText = _CalcTextSize(strDisplayFileName, ptOffset, cmmInfo.font_height);
			m_rcFileName.Width = (REAL)szText.cx;
			m_rcFileName.Height = (REAL)szText.cy;// GetCurrentLayout().common().filename_fontheight_offset;

		}
	}

		void CFTStateRecvBase::_CalcProgressExtraStatusSize( const CPoint& ptOffset )
		{
			if (!m_strProgressExtraStatus.IsEmpty())
			{
				int nDisplayType = m_pUIChatFileElement->GetElementResource()->GetChatDisplayType();
				CSize szBound = _CalcTextSize(m_strProgressExtraStatus, ptOffset, GetCurrentLayout(nDisplayType).common().font_height);
				m_rcProgressExtraStatus.Width = (REAL)szBound.cx;
				m_rcProgressExtraStatus.Height = (REAL)szBound.cy;
			}
			else
			{
				m_rcProgressExtraStatus.Width = 0.0f;
				m_rcProgressExtraStatus.Height = 0.0f;
			}
		}

		void CFTStateRecvBase::_DrawGroupButtom( Graphics *pGraph, 
			const PointF& ptGdiPOffset, RectF rc, Image* pImage, CString strText )
		{
			RectF rcDraw = rc;
			rcDraw.Offset(ptGdiPOffset);
			IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

			RectF rcDownBtn = rcDraw;
			rcDownBtn.Width = pImage->GetWidth();
			rcDownBtn.Height = pImage->GetHeight();
			if (pImage)
			{
				pGraph->DrawImage(pImage, rcDownBtn);
			}

			CSize szBound(0, 0);

			REAL fontHeight = 8;
			RecalcTextRect(pResource->GetCurrentWnd(), strText, g_defaultFontFaceName, fontHeight, 
				FontStyleRegular, pResource->GetViewRect(), szBound);

			RectF rcText;
			rcText.X = rcDownBtn.GetRight() + m_nButtonToText_X;
			rcText.Y = rcDownBtn.Y + (rcDownBtn.Height - szBound.cy) / 2;
			rcText.Width = szBound.cx;
			rcText.Height = szBound.cy;

			Gdiplus::FontStyle style =  FontStyleRegular;
			StringFormat format;
			format.SetAlignment(StringAlignmentNear);
			Gdiplus::Font txtfont(g_defaultFontFaceName, 8, style );
			SolidBrush txtbrush(CColorConvert::HEX2Color(0x2da1e9));
			pGraph->DrawString(strText.GetString(), strText.GetLength(), &txtfont, rcText, &format,  &txtbrush);
		}


		Image* CFTStateRecvBase::_GetBubbleImage( BOOL bMine, int nIndex )
		{
			IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

			if(!bMine && nIndex > 5 && nIndex < 9)
			{
				return pResource->GetBubbleBottomForRecvProcessImage(nIndex - 6);
			}

			return CFTState::_GetBubbleImage(bMine, nIndex);
		}

	CStateRecvInit::CStateRecvInit(UIChatFileElement * pUIElem)
		:CFTStateRecvBase(pUIElem)
	{
		m_pImageDown = NULL;
		m_strButtonText[Button_General] = LoadStringFromResource(IDS_CHAT_FILE_RECV_START_DOWNLOAD);
		m_bButtonIsLink[Button_General] = TRUE;
		m_bCheckDoubleClick[Button_General] = TRUE;
		m_bShowDivider = FALSE;

		int nDisplayType = m_pUIChatFileElement->GetElementResource()->GetChatDisplayType();
		if (CHAT_BUBBLE == nDisplayType)
		{
			//TODO:remove btn_talk_down.png for bubble ?
			m_fontStyleButtonText[Button_General] = FontStyleUnderline;
			m_clrButtonText[Button_General] = GetCurrentLayout(nDisplayType).common().clr_text_link;
		}
		else
		{
			m_fontStyleButtonText[Button_General] = FontStyleUnderline;
			m_clrButtonText[Button_General] = GetCurrentLayout(nDisplayType).common().clr_text_link;
		}
	}

	CStateRecvInit::~CStateRecvInit()
	{
		m_pImageDown = NULL; //will destroy by ChatMainViewElementList
	}

	//void CStateRecvInit::_CalcButtonsSize(const CPoint& ptOffset)
	//{
	//	if (!m_strButtonText[Button_General].IsEmpty())
	//	{
	//		CSize szBound = _CalcTextSize(m_strButtonText[Button_General], ptOffset);
	//		m_rcButton[Button_General].Width = (REAL)szBound.cx;
	//		m_rcButton[Button_General].Height = (REAL)szBound.cy;
	//	}
	//	else
	//	{
	//		m_rcButton[Button_General].Width = (REAL)GetCurrentLayout().recv().button_down_width;
	//		m_rcButton[Button_General].Height = (REAL)GetCurrentLayout().recv().button_down_height;
	//	}
	//}

	//BOOL CStateRecvInit::_DrawButton(Graphics *pGraph, const PointF& ptGdiPOffset)
	//{
	//	RectF rcDraw = m_rcButton[Button_General];
	//	rcDraw.Offset(ptGdiPOffset);

	//	//if (!m_pImageDown)
	//	//{
	//	//	//first load
	//	//	m_pImageDown = m_pUIChatFileElement->GetElementResource()->GetCacheImageByFilePath(TEXT("filetransfer\\btn_talk_down.png"));
	//	//}

	//	//if (m_pImageDown)
	//	{
	//		//pGraph->DrawImage(m_pImageDown, rcDraw);

	//		Gdiplus::Font font(DEFAULT_KOREAN_FONT_NAME, GetCurrentLayout().common().font_height);
	//		Gdiplus::StringFormat format;
	//		SolidBrush brush(Color::Black);
	//		pGraph->DrawString(m_strButtonText[Button_General], m_strButtonText[Button_General].GetLength(),
	//			&font, rcDraw, &format, &brush);
	//	}
	//	return TRUE;
	//}

	void CStateRecvInit::_CalcProgressSize(const CPoint& ptOffset)
	{
		m_rcProgress.Width = 0.0f;
		m_rcProgress.Height = 0.0f;
	}

	void CStateRecvInit::_OnButtonClick()
	{
		SetFocusToChatEdit();
		TRACE(TEXT("CStateRecvInit::_OnButtonClick, Will StartDownload\n"));
		m_pUIChatFileElement->GetElementResource()->StartFileTransfer(m_pUIChatFileElement->GetChatFileItem());
	}

	void CStateRecvInit::_CalcButtonsSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		Image* pDownImage = pResource->GetDownloadImage();

		CSize szBound = _CalcTextSize(m_strButtonText[Button_General], ptOffset);
		m_rcButton[Button_General].Width = (REAL)szBound.cx + m_nButtonToText_X + pDownImage->GetWidth();
		m_rcButton[Button_General].Height = (REAL)szBound.cy > pDownImage->GetHeight() ? (REAL)szBound.cy : (REAL)pDownImage->GetHeight();
		m_rcButton[Button_General].X = m_rcFileIcon.X + (m_rcFileIcon.Width - _GetBubbleCornerUnvisibleWidth() - m_rcButton[Button_General].Width) / 2;
		m_rcButton[Button_General].Y = m_rcFileIcon.GetBottom() - m_rcButton[Button_General].Height - 
			(_GetBubbleImage(FALSE, 6)->GetHeight() - m_rcButton[Button_General].Height) / 2 + 2;
	}

	BOOL CStateRecvInit::_DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset )
	{

		RectF rcDraw = m_rcButton[Button_General];
		rcDraw.Offset(ptGdiPOffset);
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		Image *pImage = pResource->GetDownloadImage();

		_DrawGroupButtom(pGraph, ptGdiPOffset, m_rcButton[Button_General], pImage, m_strButtonText[Button_General]);

		return TRUE;
	}

	CStateRecvProgress::CStateRecvProgress(UIChatFileElement * pUIElem)
		:CFTStateRecvBase(pUIElem)
	{
		m_bShowDivider = TRUE;

		if (CHAT_BUBBLE == m_pUIChatFileElement->GetElementResource()->GetChatDisplayType())
		{
			m_strButtonText[Button_General].Empty();
			m_bShowDivider = FALSE;
		}
		else
		{
			//TODO:IDS_CHAT_FILE_RECV_STATUS -- IDS_CHAT_FILE_SEND_STATUS
			m_strProgressExtraStatus = LoadStringFromResource(IDS_CHAT_FILE_RECV_STATUS);
			m_strButtonText[Button_General] = LoadStringFromResource(IDS_CHAT_FILE_CANCEL);
		}
	}
	CStateRecvProgress::~CStateRecvProgress()
	{

	}

	void CStateRecvProgress::_OnButtonClick()
	{
		SetFocusToChatEdit();
		m_pUIChatFileElement->GetElementResource()->CancelFileTransfer(m_pUIChatFileElement->GetChatFileItem());
	}

	void CStateRecvProgress::_CalcButtonsSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		Image* pImage = pResource->GetCancelDownloadImage();

		m_rcButton[Button_General].X = m_rcFileIcon.GetRight() - (REAL)m_nButtonRightEdge - pImage->GetWidth();
		m_rcButton[Button_General].Y = m_rcFileIcon.GetBottom() - (REAL)(_GetBubbleImage(FALSE, 6)->GetHeight() - pImage->GetHeight()) / 2 - pImage->GetHeight();
		m_rcButton[Button_General].Width = (REAL)pImage->GetWidth();
		m_rcButton[Button_General].Height = (REAL)pImage->GetHeight();

	}

	void CStateRecvProgress::_CalcProgressSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		if(pResource->GetChatDisplayType() == CHAT_BUBBLE)
		{
			m_rcProgress.X = m_rcFileIcon.X + (REAL)m_nProgressbarLeftEdge;
			m_rcProgress.Y = (REAL)(m_rcFileIcon.GetBottom() - (_GetBubbleImage(FALSE, 6)->GetHeight() - _GetYourProgressbarImage(0)->GetHeight()) / 2 - _GetYourProgressbarImage(0)->GetHeight());
			m_rcProgress.Width =  m_rcFileIcon.Width - (REAL)m_nProgressbarLeftEdge - (REAL)m_nProgressbarRightEdge;
			m_rcProgress.Height = (REAL)_GetYourProgressbarImage(0)->GetHeight();
		}

		else
		{
			CFTState::_CalcProgressSize(ptOffset);
		}
		
		
	}

	BOOL CStateRecvProgress::_DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset )
	{
		RectF rcDraw = m_rcButton[Button_General];
		rcDraw.Offset(ptGdiPOffset);
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		Image *pImage = pResource->GetCancelDownloadImage();

		pGraph->DrawImage(pImage, rcDraw);

		return TRUE;
	}



	CStateRecvComplete::CStateRecvComplete(UIChatFileElement * pUIElem)
		:CFTStateRecvBase(pUIElem)
	{
		m_strProgressInfo = LoadStringFromResource(IDS_CHAT_FILE_RECV_COMPLETE);
		m_strButtonText[Button_General] = LoadStringFromResource(IDS_CHAT_FILE_OPEN_FOLDER);
		m_bFileNameIsLink = TRUE;
		m_clrFileName = GetCurrentLayout(m_pUIChatFileElement->GetElementResource()->GetChatDisplayType()).common().clr_text_link;
		m_fontStyleFileName = FontStyleUnderline;
	}
	CStateRecvComplete::~CStateRecvComplete()
	{

	}

	void CStateRecvComplete::_OnButtonClick()
	{
		CChatFileItem* pChatFileItem = m_pUIChatFileElement->GetChatFileItem();
		CString strFilePath = pChatFileItem->GetTranslateFileInfo()->m_fileInfo.flepath.c_str();
		ExplorerToSpecialFile(strFilePath);
		SetFocusToChatEdit();
		//NMessageBox(m_pUIChatFileElement->GetElementResource()->GetCurrentWnd(), TEXT("Complete Button Click, will open dir"));
	}

	void CStateRecvComplete::_OnFileNameClick()
	{
		CChatFileItem* pChatFileItem = m_pUIChatFileElement->GetChatFileItem();
		CString strFilePath = pChatFileItem->GetTranslateFileInfo()->m_fileInfo.flepath.c_str();

		ShellExecute(m_pUIChatFileElement->GetElementResource()->GetCurrentWnd()->GetSafeHwnd(),
			NULL, strFilePath, NULL, NULL, SW_SHOWNORMAL);
	}

	void CStateRecvComplete::_CalcProgressSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		if(pResource->GetChatDisplayType() == CHAT_BUBBLE)
		{
			m_rcProgress.Width = 0.0f;
			m_rcProgress.Height = 0.0f;
		}
		else
		{
			CFTState::_CalcProgressSize(ptOffset);
		}
	}

	void CStateRecvComplete::_CalcButtonsSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		Image* pDownImage = pResource->GetDownloadedImage();

		CSize szBound = _CalcTextSize(m_strButtonText[Button_General], ptOffset);
		m_rcButton[Button_General].Width = (REAL)szBound.cx + m_nButtonToText_X + pDownImage->GetWidth();
		m_rcButton[Button_General].Height = (REAL)szBound.cy > pDownImage->GetHeight() ? (REAL)szBound.cy : (REAL)pDownImage->GetHeight();
		m_rcButton[Button_General].X = m_rcFileIcon.X + (m_rcFileIcon.Width - _GetBubbleCornerUnvisibleWidth() - m_rcButton[Button_General].Width) / 2;
		m_rcButton[Button_General].Y = m_rcFileIcon.GetBottom() - m_rcButton[Button_General].Height - 
			(_GetBubbleImage(FALSE, 6)->GetHeight() - m_rcButton[Button_General].Height) / 2 + 2;	
	}

	BOOL CStateRecvComplete::_DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset )
	{
		RectF rcDraw = m_rcButton[Button_General];
		rcDraw.Offset(ptGdiPOffset);
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		Image *pImage = pResource->GetDownloadedImage();

		_DrawGroupButtom(pGraph, ptGdiPOffset, m_rcButton[Button_General], pImage, m_strButtonText[Button_General]);

		return TRUE;
	}

	CStateRecvCancel::CStateRecvCancel(UIChatFileElement * pUIElem)
		:CFTStateRecvBase(pUIElem)
	{
		m_strProgressInfo = LoadStringFromResource(IDS_CHAT_FILE_RECV_CANCELED);
		m_strButtonText[Button_General] = LoadStringFromResource(IDS_CHAT_FILE_RECV_RETRY);
		m_bCheckDoubleClick[Button_General] = TRUE;
	}
	CStateRecvCancel::~CStateRecvCancel()
	{

	}

	void CStateRecvCancel::_OnButtonClick()
	{
		SetFocusToChatEdit();
		m_pUIChatFileElement->GetElementResource()->StartFileTransfer(m_pUIChatFileElement->GetChatFileItem());
	}

	void CStateRecvCancel::_CalcProgressSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		if(pResource->GetChatDisplayType() == CHAT_BUBBLE)
		{
			const commonInfo& cmmInfo = GetCurrentLayout(CHAT_BUBBLE).common();
			IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();
			REAL nFontHeight = 8;
			CSize szBound( 0, 0);
			
			RecalcTextRect(pResource->GetCurrentWnd(), m_strProgressInfo, g_defaultFontFaceName, nFontHeight, 
				FontStyleRegular, pResource->GetViewRect(), szBound);

			m_rcProgress.X = (m_BubbleInnerWidth / 2 + _GetBubbleImage(FALSE, 6)->GetWidth() - szBound.cx - 
				_GetBubbleCornerUnvisibleWidth()) / 2 + m_rcFileIcon.X + _GetBubbleCornerUnvisibleWidth();
			m_rcProgress.Y = m_rcFileIcon.GetBottom() - szBound.cy - (REAL)(_GetBubbleImage(FALSE, 6)->GetHeight() - szBound.cy) / 2;
			m_rcProgress.Width = (REAL)szBound.cx;
			m_rcProgress.Height = (REAL)szBound.cy;
		}
		else
		{
			CFTState::_CalcProgressSize(ptOffset);
		}
	}

	void CStateRecvCancel::_CalcButtonsSize( const CPoint& ptOffset )
	{
		const commonInfo& cmmInfo = GetCurrentLayout(CHAT_BUBBLE).common();
		int nRight = m_rcFileIcon.GetRight() - _GetBubbleImage(FALSE, 8)->GetWidth();

		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		Image* pImage = pResource->GetDownloadedImage();
		CSize szBound = _CalcTextSize(m_strButtonText[Button_General], ptOffset);

		m_rcButton[Button_General].Width = (REAL)szBound.cx + m_nButtonToText_X + pImage->GetWidth();
		m_rcButton[Button_General].Height = (REAL)szBound.cy > pImage->GetHeight() ? (REAL)szBound.cy : (REAL)pImage->GetHeight();
		m_rcButton[Button_General].X = m_rcDivider.GetRight() + (m_rcFileIcon.GetRight() - _GetBubbleImage(FALSE, 8)->GetWidth() - m_rcDivider.GetRight() - m_rcButton[Button_General].Width) / 2;
		m_rcButton[Button_General].Y = m_rcFileIcon.GetBottom() - m_rcButton[Button_General].Height - 
			(_GetBubbleImage(FALSE, 6)->GetHeight() - m_rcButton[Button_General].Height) / 2 + 2;
	}


	void CStateRecvCancel::_CalcDividerSize(const CPoint& ptOffset)
	{
		UINT nLeftEdge = _GetBubbleImage(FALSE, 5)->GetWidth();
		UINT nRightEdge = _GetBubbleImage(FALSE, 8)->GetWidth();

		REAL nInnerWidth = m_rcFileIcon.Width - nLeftEdge - nRightEdge;

		m_rcDivider.X = m_rcFileIcon.X + nInnerWidth / 2 + nLeftEdge;
		m_rcDivider.Y = m_rcFileIcon.GetBottom() - _GetBubbleImage(FALSE, 6)->GetHeight();
		m_rcDivider.Width = m_nDividerWidth;
		m_rcDivider.Height = _GetBubbleImage(FALSE, 6)->GetHeight();
	}

	BOOL CStateRecvCancel::_DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset )
	{
		RectF rcDraw = m_rcButton[Button_General];
		rcDraw.Offset(ptGdiPOffset);
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		Image *pImage = pResource->GetReDownloadImage();

		_DrawGroupButtom(pGraph, ptGdiPOffset, m_rcButton[Button_General], pImage, m_strButtonText[Button_General]);

		return TRUE;
	}

	CStateRecvError::CStateRecvError(UIChatFileElement * pUIElem)
		:CFTStateRecvBase(pUIElem)
	{
		m_strProgressInfo = LoadStringFromResource(IDS_CHAT_FILE_RECV_ERROR);
		m_strButtonText[Button_General] = LoadStringFromResource(IDS_CHAT_FILE_RECV_RETRY);
		m_bCheckDoubleClick[Button_General] = TRUE;
	}

	CStateRecvError::~CStateRecvError()
	{

	}

	void CStateRecvError::_CalcProgressSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		if(pResource->GetChatDisplayType() == CHAT_BUBBLE)
		{
			const commonInfo& cmmInfo = GetCurrentLayout(CHAT_BUBBLE).common();
			IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();
			REAL nFontHeight = 8;
			CSize szBound( 0, 0);

			RecalcTextRect(pResource->GetCurrentWnd(), m_strProgressInfo, g_defaultFontFaceName, nFontHeight, 
				FontStyleRegular, pResource->GetViewRect(), szBound);

			m_rcProgress.X = (m_BubbleInnerWidth / 2 + _GetBubbleImage(FALSE, 6)->GetWidth() - szBound.cx - 
				_GetBubbleCornerUnvisibleWidth()) / 2 + m_rcFileIcon.X + _GetBubbleCornerUnvisibleWidth();
			m_rcProgress.Y = m_rcFileIcon.GetBottom() - szBound.cy - (REAL)(_GetBubbleImage(FALSE, 6)->GetHeight() - szBound.cy) / 2;
			m_rcProgress.Width = (REAL)szBound.cx;
			m_rcProgress.Height = (REAL)szBound.cy;
		}
		else
		{
			CFTState::_CalcProgressSize(ptOffset);
		}
	}

	void CStateRecvError::_OnButtonClick()
	{
		SetFocusToChatEdit();
		m_pUIChatFileElement->GetElementResource()->StartFileTransfer(m_pUIChatFileElement->GetChatFileItem());
	
	}


	void CStateRecvError::_CalcButtonsSize( const CPoint& ptOffset )
	{
		const commonInfo& cmmInfo = GetCurrentLayout(CHAT_BUBBLE).common();
		int nRight = m_rcFileIcon.GetRight() - _GetBubbleImage(FALSE, 8)->GetWidth();

		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		Image* pImage = pResource->GetDownloadedImage();
		CSize szBound = _CalcTextSize(m_strButtonText[Button_General], ptOffset);

		m_rcButton[Button_General].Width = (REAL)szBound.cx + m_nButtonToText_X + pImage->GetWidth();
		m_rcButton[Button_General].Height = (REAL)szBound.cy > pImage->GetHeight() ? (REAL)szBound.cy : (REAL)pImage->GetHeight();
		m_rcButton[Button_General].X = m_rcDivider.GetRight() + (m_rcFileIcon.GetRight() - _GetBubbleImage(FALSE, 8)->GetWidth() - m_rcDivider.GetRight() - m_rcButton[Button_General].Width) / 2;
		m_rcButton[Button_General].Y = m_rcFileIcon.GetBottom() - m_rcButton[Button_General].Height - 
			(_GetBubbleImage(FALSE, 6)->GetHeight() - m_rcButton[Button_General].Height) / 2 + 2;
	}


	void CStateRecvError::_CalcDividerSize(const CPoint& ptOffset)
	{
		UINT nLeftEdge = _GetBubbleImage(FALSE, 5)->GetWidth();
		UINT nRightEdge = _GetBubbleImage(FALSE, 8)->GetWidth();

		REAL nInnerWidth = m_rcFileIcon.Width - nLeftEdge - nRightEdge;

		m_rcDivider.X = m_rcFileIcon.X + nInnerWidth / 2 + nLeftEdge;
		m_rcDivider.Y = m_rcFileIcon.GetBottom() - _GetBubbleImage(FALSE, 6)->GetHeight();
		m_rcDivider.Width = m_nDividerWidth;
		m_rcDivider.Height = _GetBubbleImage(FALSE, 6)->GetHeight();
	}

	BOOL CStateRecvError::_DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset )
	{
		RectF rcDraw = m_rcButton[Button_General];
		rcDraw.Offset(ptGdiPOffset);
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		Image *pImage = pResource->GetReDownloadImage();

		_DrawGroupButtom(pGraph, ptGdiPOffset, m_rcButton[Button_General], pImage, m_strButtonText[Button_General]);

		return TRUE;
	}

}